# Installation tasks

from java.lang import *
from java.io   import *
from java.util import *
from java.io   import BufferedReader, FileReader, File, FileInputStream
from java.lang import String, System

from com.axway.synchronyInstaller.engine import *
from com.axway.synchronyInstaller.util import *
from com.axway.synchronyInstaller.database import *
import synScript

class Script_taskCommon(synScript.SynScript):
    def __init__(self, installManager):
        synScript.SynScript.__init__(self, installManager)

        self.sep = SynFile.separator

    #
    # Execute a script (e.g. used for import license)
    #
    def executeScript(self, component, osName, scriptName, argName1, argValue1, argName2, argValue2, argName3, argValue3):

        scriptInstallationPath = component.getInstallationDirectoryFullName() + "extra" + self.sep + "installTools" + self.sep + scriptName

        task = SynJTaskOSSpecificScript(osName, "", scriptInstallationPath, 1, File(component.getInstallationDirectoryFullName()))
        task.addArgument(argName1)
        task.addArgument(argValue1)
        task.addArgument(argName2)
        task.addArgument(argValue2)
        task.addArgument(argName3)
        task.addArgument(argValue3)
        task.setHidden()
        task.setIgnoreError()

        component.addTask(None, "ExecuteScriptCommand_" + argValue1 + "_" + argValue2 + "_" + argValue3, "Execute Script command " + argValue1 + "_" + argValue2 + "_" + argValue3, task)

        return None

    def createOrUpdateAISRepositoryDBEntry(self, component):
        configDir = self.installationDirectory + "extra" + self.sep + "installTools" + self.sep + "configuration"

        dbUrl = self.variableManager.getVariable("AISRepositoryDBUrl")
        dbName = self.variableManager.getVariable("AISRepositoryDBName")
        dbUser = self.variableManager.getVariable("AISRepositoryDBUser")
        dbPassword = self.variableManager.getVariable("AISRepositoryDBPassword")
        dbDriver = self.variableManager.getVariable("AISRepositoryDBDriver")

        # Update the AIS Repository DB properties in installTools.properties file
        taskUpdatePropFile = SynJTaskPropertyFile(configDir + self.sep + "installTools.properties")
        taskUpdatePropFile.updateProperty("AISRepoDBUser", dbUser, 1)
        taskUpdatePropFile.updateProperty("AISRepoDBPassword" , dbPassword, 1)
        taskUpdatePropFile.updateProperty("AISRepoDBDriver", dbDriver, 1)
        taskUpdatePropFile.updateProperty("AISRepoDBUrl", dbUrl, 1)
        taskUpdatePropFile.setHidden()
        component.addTask("ConfigureDatastore", "UpdateAISRepoDBInDSInstallToolsPropertyFile", "Update Repository DB in installTools.properties file", taskUpdatePropFile)


    def createAISRepositoryDBEntry(self, component):
        self.createOrUpdateAISRepositoryDBEntry(component)

        return None

    def updateAISRepositoryDBEntry(self, component):
        self.createOrUpdateAISRepositoryDBEntry(component)

        return None
